/*
* This file is part of project OpenEmbroidery. It's copyrighted by
* the contributors recorded in the version control history of the file.
* Original project location https://code.electrolab.fr/openEmbroidery/openEmbroidery_software
*
* SPDX-License-Identifier: CECILL-2.1
* License-Filename: Licence_CeCILL_V2.1-en.txt
*/

#pragma once

#include "actions/OE_actions.h"
#include "OE_thread.h"

class OE_actionNewThread : public OE_actions
{
	public:
		OE_actionNewThread(OE_document* doc, OE_thread* thread);

		virtual ~OE_actionNewThread();

		virtual void undo();
		virtual void redo();

	protected:
		OE_thread* actionThread;
};

class OE_actionDelThread : public OE_actions
{
	public:
		OE_actionDelThread(OE_document* doc, OE_thread* thread);

		virtual ~OE_actionDelThread();

		virtual void undo();
		virtual void redo();

	protected:
		OE_thread* actionThread;
};

class OE_actionThreadColor : public OE_actions
{
	public:
		OE_actionThreadColor(OE_document* doc, OE_thread* thread, OE_color color);

		virtual ~OE_actionThreadColor();

		virtual void undo();
		virtual void redo();

	protected:
		OE_thread* actionThread;
		OE_color oldColor;
};

class OE_actionThreadWidth : public OE_actions
{
	public:
		OE_actionThreadWidth(OE_document* doc, OE_thread* thread, float width);

		virtual ~OE_actionThreadWidth();

		virtual void undo();
		virtual void redo();

	protected:
		OE_thread* actionThread;
		float oldWidth;
};

//bool setThreadColor(unsigned index, unsigned char r, unsigned char g, unsigned char b );
//bool setThreadWidth(unsigned index, float width );

